//----------------------------------------------------------------------------------
//		AV[v}XNvOC By  BS
//		Version 0.02
//
//		$Log: unsharpns.cpp,v $
//		Revision 1.17  2009-02-20 19:07:19+09  Blacksword
//		Improved Readability.
//
//		Revision 1.16  2009/02/19 03:28:42  Blacksword
//		Added PickY.
//
//		Revision 1.15  2009-02-17 10:21:49+09  Blacksword
//		Optimzied Cache Control in unsharp0.
//
//		Revision 1.14  2009-02-17 06:37:17+09  Blacksword
//		Reduced size of workarea and speedup.
//
//		last mod $Id: unsharpns.cpp,v 1.17 2009-02-20 19:07:19+09 Blacksword Exp $
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <math.h>
#include "filter.h"
#include "simdemul.h"

//---------------------------------------------------------------------
//		vg^Cv錾
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp );
BOOL func_update( FILTER *fp );
//---------------------------------------------------------------------
//		O[oϐ
//---------------------------------------------------------------------
static float threshold;						// 臒l
static float tap;							// vf
static int fixed_w;							// ACg
static __m128 PRANGE, pstr, pthres ,ptap;
static float *luma_xtotal = NULL;			// Xvli[̈
static int cur_w = 0, cur_h = 0;			// i[̈̉摜TCY

typedef struct {
	FILTER				*fp;
	FILTER_PROC_INFO	*fpip;
	float *ybuf;
	float *luma_xtotal;
} FILTER_PARAM;

_MM_ALIGN16 const unsigned long PABSMASK[4]	 = {0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF};	// _Βlp

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define	TRACK_N	3														//	gbNo[̐
TCHAR	*track_name[] =		{	"K",	"͈",	"臒l",	};	//	gbNo[̖O
int		track_default[] =	{	25,	10,	50,	};	//	gbNo[̏l
int		track_s[] =			{	1,	1,	0,	};	//	gbNo[̉l
int		track_e[] =			{	+500,	+20,	+500,	};	//	gbNo[̏l

#define	CHECK_N	0														//	`FbN{bNX̐

#define tSTR	0
#define tRANGE	1
#define tTHRES	2

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,	//	tB^̃tO
	0,0,						//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"AV[v}XNMT",			//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	NULL	,					//	`FbN{bNX̖OSւ̃|C^
	NULL,						//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_exit,					//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_update,				//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
#if defined(SSE41)
	"AV[v}XNMT(SSE4.1) ver0.02 by BS",
#elif defined(SSSE3)
	"AV[v}XNMT(SSSE3) ver0.02 by BS",
#elif defined(SSE3)
	"AV[v}XNMT(SSE3) ver0.02 by BS",
#elif defined(SSE2)
	"AV[v}XNMT(SSE2) ver0.02 by BS",
#endif
	//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

//---------------------------------------------------------------------
//		fobN֌W
//---------------------------------------------------------------------
#if defined(DEBUG)
#include <stdio.h>
#include <stdlib.h>
static LARGE_INTEGER prof_s[16], prof_e[16], pfreq;
static double prof_r[16];

static void _perf_result(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	QueryPerformanceFrequency(&pfreq);
	HFONT hFont = CreateFont(16, 0, 0, 0, FW_REGULAR, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH|FF_MODERN,
		"lr SVbN" );

	char stmp[1024];
	for(int i=0;i<3;i++)
		prof_r[i] = (double)(prof_e[i].QuadPart-prof_s[i].QuadPart)/(double)pfreq.QuadPart;
	sprintf_s(stmp, sizeof(stmp), 
		"unsharp0:%1.5e\n"
		"unsharp1:%1.5e\n"
		"     all:%1.5e\n",
		prof_r[1], prof_r[2], prof_r[0]);
	fp->exfunc->draw_text(fpip->ycp_edit, 48, 48, stmp, 255, 255, 255, 0,hFont, NULL, NULL);
	DeleteObject(hFont);
}
#endif
//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}
//---------------------------------------------------------------------
//		tB^ݒύX֐
//---------------------------------------------------------------------
BOOL func_update( FILTER *fp, int status )
{
	threshold = (float)fp->track[tTHRES]*2.f;	//臒lB2{͓KȒlB
	tap = (float)(fp->track[tRANGE] * 2 + 1)*(fp->track[tRANGE] * 2 + 1);

	return TRUE;
}
/*--------------------------------------------------------------------
*	Yo
*-------------------------------------------------------------------*/
static __inline void PickY(float *dst, short *src, int wa, int w)
{
	int x;
	// YvfoEϊ(1/2)
	for(x=0;x<wa;x+=16){
		__m128i r0, r1, r2, r3;
#if defined(SSE41)
		r0 = _mm_insert_epi16(r0, *(src   ), 0);
		r1 = _mm_insert_epi16(r1, *(src+12), 0);
		r2 = _mm_insert_epi16(r2, *(src+24), 0);
		r3 = _mm_insert_epi16(r3, *(src+36), 0);
		r0 = _mm_insert_epi16(r0, *(src+ 3), 1);
		r1 = _mm_insert_epi16(r1, *(src+15), 1);
		r2 = _mm_insert_epi16(r2, *(src+27), 1);
		r3 = _mm_insert_epi16(r3, *(src+39), 1);
		r0 = _mm_insert_epi16(r0, *(src+ 6), 2);
		r1 = _mm_insert_epi16(r1, *(src+18), 2);
		r2 = _mm_insert_epi16(r2, *(src+30), 2);
		r3 = _mm_insert_epi16(r3, *(src+42), 2);
		r0 = _mm_insert_epi16(r0, *(src+ 9), 3);
		r1 = _mm_insert_epi16(r1, *(src+21), 3);
		r2 = _mm_insert_epi16(r2, *(src+33), 3);
		r3 = _mm_insert_epi16(r3, *(src+45), 3);
		r0 = _mm_cvtepi16_epi32(r0);
		r1 = _mm_cvtepi16_epi32(r1);
		r2 = _mm_cvtepi16_epi32(r2);
		r3 = _mm_cvtepi16_epi32(r3);
		r0 = _mm_castps_si128(_mm_cvtepi32_ps(r0));
		r1 = _mm_castps_si128(_mm_cvtepi32_ps(r1));
		r2 = _mm_castps_si128(_mm_cvtepi32_ps(r2));
		r3 = _mm_castps_si128(_mm_cvtepi32_ps(r3));
		_mm_store_si128((__m128i*)(dst   ), r0);
		_mm_store_si128((__m128i*)(dst+ 4), r1);
		_mm_store_si128((__m128i*)(dst+ 8), r2);
		_mm_store_si128((__m128i*)(dst+12), r3);
#else
		__m128i r4, r5;
		r0 = _mm_insert_epi16(r0, *(src   ), 0);
		r1 = _mm_insert_epi16(r1, *(src+24), 0);
		r0 = _mm_insert_epi16(r0, *(src+ 3), 1);
		r1 = _mm_insert_epi16(r1, *(src+27), 1);
		r0 = _mm_insert_epi16(r0, *(src+ 6), 2);
		r1 = _mm_insert_epi16(r1, *(src+30), 2);
		r0 = _mm_insert_epi16(r0, *(src+ 9), 3);
		r1 = _mm_insert_epi16(r1, *(src+33), 3);
		r0 = _mm_insert_epi16(r0, *(src+12), 4);
		r1 = _mm_insert_epi16(r1, *(src+36), 4);
		r0 = _mm_insert_epi16(r0, *(src+15), 5);
		r1 = _mm_insert_epi16(r1, *(src+39), 5);
		r0 = _mm_insert_epi16(r0, *(src+18), 6);
		r1 = _mm_insert_epi16(r1, *(src+42), 6);
		r0 = _mm_insert_epi16(r0, *(src+21), 7);
		r1 = _mm_insert_epi16(r1, *(src+45), 7);
		r4 = _mm_setzero_si128();
		r5 = _mm_setzero_si128();
		r2 = r0;
		r3 = r1;
		r4 = _mm_cmpgt_epi16(r4, r0);
		r5 = _mm_cmpgt_epi16(r5, r1);
		r0 = _mm_unpacklo_epi16(r0, r4);
		r2 = _mm_unpackhi_epi16(r2, r4);
		r1 = _mm_unpacklo_epi16(r1, r5);
		r3 = _mm_unpackhi_epi16(r3, r5);
		r0 = _mm_castps_si128(_mm_cvtepi32_ps(r0));
		r2 = _mm_castps_si128(_mm_cvtepi32_ps(r2));
		r1 = _mm_castps_si128(_mm_cvtepi32_ps(r1));
		r3 = _mm_castps_si128(_mm_cvtepi32_ps(r3));
		_mm_store_si128((__m128i*)(dst   ), r0);
		_mm_store_si128((__m128i*)(dst+ 4), r2);
		_mm_store_si128((__m128i*)(dst+ 8), r1);
		_mm_store_si128((__m128i*)(dst+12), r3);
#endif
		src += 48;
		dst += 16;
	}
	for(;x<w;x++){
		*dst = (float)*src;
		src += 3;
		dst += 1;
	}
}
/*--------------------------------------------------------------------
*	AV[vO(Yo+Xv)	(MT)
*		̏ł̓}`Xbhc
*-------------------------------------------------------------------*/
static void unsharp0(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				 = ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	 = ((FILTER_PARAM *)param1)->fpip;
	float *ybuf				 = ((FILTER_PARAM *)param1)->ybuf;
	float *luma				 = ((FILTER_PARAM *)param1)->luma_xtotal;

	int x, y;
	int speed_up = (fpip->max_w - fpip->w)*3,
		speed_up2 = fixed_w - fpip->w,
		speed_up3 = speed_up2 +fixed_w,
		speed_up4 = fpip->w-fp->track[tRANGE];
	float *y1, *y2;
	int y_simd2;

	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num);

	short *src = (short*)fpip->ycp_edit;

	//XbhƂ̏ʒuɏC
	src += y_start * fpip->max_w * 3;
	const int x_simd16  = fpip->w&(~15);

	luma += fixed_w * y_start;
	y_simd2 = ((y_end-y_start)&(~1))+y_start;

	for(y=y_start;y<y_end;y+=2){
		__m128 r0, r1, r2, r3, r4, r5;
		y1  = ybuf + y * fixed_w;
		y2 = y1 + fp->track[tRANGE] + 1;

		// YvfoEϊ
		PickY(y1        , src              , x_simd16, fpip->w);
		PickY(y1+fixed_w, src+fpip->max_w*3, x_simd16, fpip->w);
		src += fpip->max_w * 6;

		// Xv(2C)

		r0 = _mm_load_ss(y1        );
		r3 = _mm_load_ss(y1+fixed_w);
		r0 = _mm_mul_ss(r0, PRANGE);
		r3 = _mm_mul_ss(r3, PRANGE);
		for(x=0;x<=fp->track[tRANGE];x++){
			r1 = _mm_load_ss(y1+x        );
			r4 = _mm_load_ss(y1+x+fixed_w);
			r0 = _mm_add_ss(r0, r1);
			r3 = _mm_add_ss(r3, r4);
		}
		_mm_store_ss(luma        , r0);
		_mm_store_ss(luma+fixed_w, r3);
		luma++;
		r1 = _mm_load_ss(y1        );
		r4 = _mm_load_ss(y1+fixed_w);
		for(x=1;x<=fp->track[tRANGE];x++){
			r2 = _mm_load_ss(y2        );
			r5 = _mm_load_ss(y2+fixed_w);
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_add_ss(r3, r5);
			r0 = _mm_sub_ss(r0, r1);
			r3 = _mm_sub_ss(r3, r4);
			_mm_store_ss(luma        , r0);
			_mm_store_ss(luma+fixed_w, r3);
			luma++;	y2++;
		}
		for(x=fp->track[tRANGE]+1;x<speed_up4;x++){
			r1 = _mm_load_ss(y1        );
			r4 = _mm_load_ss(y1+fixed_w);
			r2 = _mm_load_ss(y2        );
			r5 = _mm_load_ss(y2+fixed_w);
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_add_ss(r3, r5);
			r0 = _mm_sub_ss(r0, r1);
			r3 = _mm_sub_ss(r3, r4);
			_mm_store_ss(luma        , r0);
			_mm_store_ss(luma+fixed_w, r3);
			luma++;	y1++;	y2++;
		}
		for(x=fpip->w-fp->track[tRANGE];x<fpip->w;x++){
			r1 = _mm_load_ss(y1        );
			r4 = _mm_load_ss(y1+fixed_w);
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_add_ss(r3, r5);
			r0 = _mm_sub_ss(r0, r1);
			r3 = _mm_sub_ss(r3, r4);
			_mm_store_ss(luma        , r0);
			_mm_store_ss(luma+fixed_w, r3);
			luma++;	y1++;
		}
		luma += speed_up3;
	}
	for(         ;y<y_end;y++){
		__m128 r0, r1, r2, r3;
		y1  = ybuf + y * fixed_w;

		// YvfoEϊ
		PickY(y1        , src              , x_simd16, fpip->w);
		src += fpip->max_w * 3;

		// Xv
		y1 = ybuf + y * fixed_w;
		y2 = y1 + fp->track[tRANGE] + 1;

		r0 = _mm_load_ss(y1);
		r0 = _mm_mul_ss(r0, PRANGE);
		for(x=0;x<=fp->track[tRANGE];x++){
			r1 = _mm_load_ss(y1+x);
			r0 = _mm_add_ss(r0, r1);
		}
		_mm_store_ss(luma, r0);
		luma++;
		r1 = _mm_load_ss(y1);
		for(x=1;x<=fp->track[tRANGE];x++){
			r2 = _mm_load_ss(y2);
			r0 = _mm_add_ss(r0, r2);
			r0 = _mm_sub_ss(r0, r1);
			_mm_store_ss(luma, r0);
			luma++;	y2++;
		}
		for(x=fp->track[tRANGE]+1;x<speed_up4;x++){
			r1 = _mm_load_ss(y1);
			r2 = _mm_load_ss(y2);
			r0 = _mm_add_ss(r0, r2);
			r0 = _mm_sub_ss(r0, r1);
			_mm_store_ss(luma, r0);
			luma++;	y1++;	y2++;
		}
		for(x=fpip->w-fp->track[tRANGE];x<fpip->w;x++){
			r1 = _mm_load_ss(y1);
			r0 = _mm_add_ss(r0, r2);
			r0 = _mm_sub_ss(r0, r1);
			_mm_store_ss(luma, r0);
			luma++;	y1++;
		}
		luma += speed_up2;
	}
}
/*--------------------------------------------------------------------
*	AV[v㔼(yv+AV[v)	(MT)
*		̏ł̓}`Xbh
*-------------------------------------------------------------------*/
static void unsharp1(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				 = ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	 = ((FILTER_PARAM *)param1)->fpip;
	float *ybuf				 = ((FILTER_PARAM *)param1)->ybuf;
	float *luma_xtotal		 = ((FILTER_PARAM *)param1)->luma_xtotal;

	int x_start = ( fixed_w * thread_id     ) / thread_num;
	int x_end   = (( fixed_w * (thread_id+1) ) / thread_num);
	x_start = x_start&(~7);
	x_end = x_end&(~7);
	if(thread_id+1==thread_num)
		x_end = fpip->w;

	int x, y;
	int speed_up  = fpip->h-fp->track[tRANGE],
		speed_up2 = (1 + fp->track[tRANGE])*fixed_w;
	int W4 = ((x_end-x_start)&(~3)) + x_start;
	//---------------------------------------------------------------------
	//	yv + AV[v}XN
	//---------------------------------------------------------------------
	float *luma_x1, *luma_x2;

	for(x=x_start;x<W4;x+=4){
		__m128 r0, r1, r2;
		luma_x1 = luma_xtotal + x;
		luma_x2 = luma_x1 + speed_up2;
		PIXEL_YC* ycp = fpip->ycp_edit + x;
		float *yp = ybuf + x;

		r0 = _mm_stream_load_ps(luma_x1  );
		r1 = r0;
		r0 = _mm_mul_ps(r0, PRANGE);
		for(y=0;y<=fp->track[tRANGE];y++){
			r2 = _mm_stream_load_ps(luma_x1+y*fixed_w  );
			r0 = _mm_add_ps(r0, r2);
		}
		{
			__m128 r3, r4, r5;
			r3 = _mm_stream_load_ps(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ps(r4, ptap);
			r5 = _mm_sub_ps(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ps(r5, pthres);
			if(_mm_movemask_ps(r5))
			{
				r4 = _mm_and_ps(r4, r5);
				r4 = _mm_mul_ps(r4, pstr);
				r3 = _mm_add_ps(r3, r4);
				r3 = _mm_castsi128_ps(_mm_cvtps_epi32(r3));
				(ycp  )->y = _mm_extract_epi16(_mm_castps_si128(r3), 0);
				(ycp+1)->y = _mm_extract_epi16(_mm_castps_si128(r3), 2);
				(ycp+2)->y = _mm_extract_epi16(_mm_castps_si128(r3), 4);
				(ycp+3)->y = _mm_extract_epi16(_mm_castps_si128(r3), 6);
			}
			ycp += fpip->max_w;
			yp += fixed_w;
		}
		for(y=1;y<=fp->track[tRANGE];y++){
			__m128 r3, r4, r5;
			r2 = _mm_stream_load_ps(luma_x2  );
			r0 = _mm_sub_ps(r0, r1);
			r0 = _mm_add_ps(r0, r2);
			r3 = _mm_stream_load_ps(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ps(r4, ptap);
			r5 = _mm_sub_ps(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ps(r5, pthres);
			if(_mm_movemask_ps(r5))
			{
				r4 = _mm_and_ps(r4, r5);
				r4 = _mm_mul_ps(r4, pstr);
				r3 = _mm_add_ps(r3, r4);
				r3 = _mm_castsi128_ps(_mm_cvtps_epi32(r3));
				(ycp  )->y = _mm_extract_epi16(_mm_castps_si128(r3), 0);
				(ycp+1)->y = _mm_extract_epi16(_mm_castps_si128(r3), 2);
				(ycp+2)->y = _mm_extract_epi16(_mm_castps_si128(r3), 4);
				(ycp+3)->y = _mm_extract_epi16(_mm_castps_si128(r3), 6);
			}
			ycp += fpip->max_w;
			yp += fixed_w;
			luma_x2 += fixed_w;
		}
		for(y=fp->track[tRANGE]+1;y<speed_up;y++){
			__m128 r3, r4, r5;
			r1 = _mm_stream_load_ps(luma_x1  );
			r2 = _mm_stream_load_ps(luma_x2  );
			r0 = _mm_sub_ps(r0, r1);
			r0 = _mm_add_ps(r0, r2);
			r3 = _mm_stream_load_ps(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ps(r4, ptap);
			r5 = _mm_sub_ps(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ps(r5, pthres);
			if(_mm_movemask_ps(r5))
			{
				r4 = _mm_and_ps(r4, r5);
				r4 = _mm_mul_ps(r4, pstr);
				r3 = _mm_add_ps(r3, r4);
				r3 = _mm_castsi128_ps(_mm_cvtps_epi32(r3));
				(ycp  )->y = _mm_extract_epi16(_mm_castps_si128(r3), 0);
				(ycp+1)->y = _mm_extract_epi16(_mm_castps_si128(r3), 2);
				(ycp+2)->y = _mm_extract_epi16(_mm_castps_si128(r3), 4);
				(ycp+3)->y = _mm_extract_epi16(_mm_castps_si128(r3), 6);
			}
			ycp += fpip->max_w;
			yp += fixed_w;
			luma_x1 += fixed_w;	luma_x2 += fixed_w;
		}
		for(y=speed_up;y<fpip->h;y++){
			__m128 r3, r4, r5;
			r1 = _mm_stream_load_ps(luma_x1  );
			r0 = _mm_sub_ps(r0, r1);
			r0 = _mm_add_ps(r0, r2);
			r3 = _mm_stream_load_ps(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ps(r4, ptap);
			r5 = _mm_sub_ps(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ps(r5, pthres);
			if(_mm_movemask_ps(r5))
			{
				r4 = _mm_and_ps(r4, r5);
				r4 = _mm_mul_ps(r4, pstr);
				r3 = _mm_add_ps(r3, r4);
				r3 = _mm_castsi128_ps(_mm_cvtps_epi32(r3));
				(ycp  )->y = _mm_extract_epi16(_mm_castps_si128(r3), 0);
				(ycp+1)->y = _mm_extract_epi16(_mm_castps_si128(r3), 2);
				(ycp+2)->y = _mm_extract_epi16(_mm_castps_si128(r3), 4);
				(ycp+3)->y = _mm_extract_epi16(_mm_castps_si128(r3), 6);
			}
			ycp += fpip->max_w;
			yp += fixed_w;
			luma_x1 += fixed_w;
		}
	}
	for(         ;x<x_end;x++){
		__m128 r0, r1, r2;
		luma_x1 = luma_xtotal + x;
		luma_x2 = luma_x1 + speed_up2;
		PIXEL_YC* ycp = fpip->ycp_edit + x;
		float *yp = ybuf + x;

		r0 = _mm_load_ps(luma_x1  );
		r1 = r0;
		r0 = _mm_mul_ss(r0, PRANGE);
		for(y=0;y<=fp->track[tRANGE];y++){
			__m128 r3, r4, r5;
			r2 = _mm_load_ss(luma_x1+y*fixed_w  );
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_load_ss(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ss(r4, ptap);
			r5 = _mm_sub_ss(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ss(r5, pthres);
			r4 = _mm_and_ps(r4, r5);
			r4 = _mm_mul_ss(r4, pstr);
			r3 = _mm_add_ss(r3, r4);
			(ycp  )->y = (short)_mm_cvtss_si32(r3);
			ycp += fpip->max_w;
			yp += fixed_w;
		}
		for(y=1;y<=fp->track[tRANGE];y++){
			__m128 r3, r4, r5;
			r2 = _mm_load_ss(luma_x2  );
			r0 = _mm_sub_ss(r0, r1);
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_load_ss(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ss(r4, ptap);
			r5 = _mm_sub_ss(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ss(r5, pthres);
			r4 = _mm_and_ps(r4, r5);
			r4 = _mm_mul_ss(r4, pstr);
			r3 = _mm_add_ss(r3, r4);
			(ycp  )->y = (short)_mm_cvtss_si32(r3);
			ycp += fpip->max_w;
			yp += fixed_w;
			luma_x2 += fixed_w;
		}
		for(y=fp->track[tRANGE]+1;y<speed_up;y++){
			__m128 r3, r4, r5;
			r1 = _mm_load_ss(luma_x1  );
			r2 = _mm_load_ss(luma_x2  );
			r0 = _mm_sub_ss(r0, r1);
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_load_ss(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ss(r4, ptap);
			r5 = _mm_sub_ss(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ss(r5, pthres);
			r4 = _mm_and_ps(r4, r5);
			r4 = _mm_mul_ss(r4, pstr);
			r3 = _mm_add_ss(r3, r4);
			(ycp  )->y = (short)_mm_cvtss_si32(r3);
			ycp += fpip->max_w;
			yp += fixed_w;
			luma_x1 += fixed_w;	luma_x2 += fixed_w;
		}
		for(y=speed_up;y<fpip->h;y++){
			__m128 r3, r4, r5;
			r1 = _mm_load_ss(luma_x1  );
			r0 = _mm_sub_ss(r0, r1);
			r0 = _mm_add_ss(r0, r2);
			r3 = _mm_load_ss(yp);
			r4 = r0;
			r5 = r3;
			r4 = _mm_mul_ss(r4, ptap);
			r5 = _mm_sub_ss(r5, r4);
			r4 = r5;
			r5 = _mm_and_ps(r5, *(__m128*)PABSMASK);
			r5 = _mm_cmpgt_ss(r5, pthres);
			r4 = _mm_and_ps(r4, r5);
			r4 = _mm_mul_ss(r4, pstr);
			r3 = _mm_add_ss(r3, r4);
			(ycp  )->y = (short)_mm_cvtss_si32(r3);
			ycp += fpip->max_w;
			yp += fixed_w;
			luma_x1 += fixed_w;
		}
	}
}
//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
#if defined(DEBUG)
	QueryPerformanceCounter(&prof_s[0]);
#endif
	fixed_w = (fpip->w+7)&(~7);
	PRANGE = _mm_set1_ps((float)(fp->track[tRANGE]));
	pstr = _mm_set1_ps((float)(fp->track[tSTR])/100.f);
	pthres = _mm_set1_ps(threshold);
	ptap = _mm_set1_ps(1.f/tap);

	float* ybuf = (float*)fpip->ycp_temp;
	// 16oCgACg␳
	if(((int)ybuf)&0xF)
	{
		char* btemp = (char*)ybuf;
		btemp += (16-(((int)btemp)&0xF));
		ybuf = (float*)btemp;
	}
	int memsize = fixed_w*fpip->h;
	// LĂTCYƈႤꍇ̓Ċm
	if(fpip->w!=cur_w||fpip->h!=cur_h)
	{
		// 16oCgACgΉrealloc͂Ȃ̂ŊJ->Ċm
		if(luma_xtotal!=NULL)
			_mm_free(luma_xtotal);
		// Imۂ͌\Ԃ򂤂̂ōŒ
		luma_xtotal = (float*)_mm_malloc(memsize*sizeof(float), 16);
		cur_w = fpip->w;
		cur_h = fpip->h;
	}

	FILTER_PARAM filter_param = {fp, fpip, ybuf, luma_xtotal};
	// Xbhgp͍ŏ
#if defined(DEBUG)
	QueryPerformanceCounter(&prof_s[1]);
#endif
	// Yo{Xv
	fp->exfunc->exec_multi_thread_func(unsharp0, (void *)&filter_param, NULL);
#if defined(DEBUG)
	QueryPerformanceCounter(&prof_e[1]);
	QueryPerformanceCounter(&prof_s[2]);
#endif
	// Yv{AV[v}XN
	fp->exfunc->exec_multi_thread_func(unsharp1, (void *)&filter_param, NULL);
#if defined(DEBUG)
	QueryPerformanceCounter(&prof_e[2]);
#endif

#if defined(DEBUG)
	QueryPerformanceCounter(&prof_e[0]);
	_perf_result(fp, fpip);
#endif
	return TRUE;
}
//---------------------------------------------------------------------
//		tB^I֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
	// mۂĂ[NGAJ
	if(luma_xtotal!=NULL)
		_mm_free(luma_xtotal);
	return TRUE;
}
